#!/usr/bin/perl

# ç Խǰ Ϲڽ  RSS feed ϴ perl script
# status: unstable
# revision:
# 	2004 4 22 ó 
# :
# 	..../freechal.pl?url=<ç Խ url ü >
# 	̶, url   Ե & ڴ %26 ġȯ־ Ѵ!
# 	  йȣ ؼ   ִ Խ ,
# 	Ʒ userid password  ־ Ѵ.
# 	url query ʰ, userid password ָ ڽ 
# 	ç  ڽ  RSS Ѵ.

use LWP;
use URI;
use HTTP::Cookies;
use XML::RSS;
use CGI qw(:standard);

##
# Configurations
#

# Community     н尡 ʿ 찡 ִ. йȣ
# ⿡ ϶
#$userid = "XXXX";
#$password = "XXXX";

##
# Configurations from the query string
#
if(param())
{
	$url = param('url'); # Խ URL;    Ϲڽ
	$rss_version = param('ver'); # RSS version
	$debug = param('debug'); # debugging mode
	# debugging mode XML RSS ƴ Text Ѵ.
}

# RSS  ⺻
$rss_version = '1.0' unless($rss_version);

##
# HTTP Header
# 
$content_type = $debug ? "Content-type: text/plain" : 
		"Content-type: application/xml";
print $content_type."\n\n";


if($url =~ /(.+\/).+GrpId=([0-9]+)/)
{
	$base_url = $1; # Խ 丮 
	$boardid = $2; # Խ ID
}

if($debug)
{
	print "URL: $url\n";
	print "BaseURL: $base_url\nGroupID: $boardid\n";
	print "ID: $userid, version: $rss_version\n";
}

my $login_url= "http://login.freechal.com/FcNwVerify.asp";
my $rss = new XML::RSS(encoding=>"euc-kr");
my $cookie = "";
my $browser =  LWP::UserAgent->new;

##
# ÿ ID/PW αѴ.
#
sub freechal_login{
	my ($userid, $password) = @_;

	#login freechal
    my $response = $browser->post($login_url,
		[
			'UserID' => $userid,
			'Password' => $password
		],
	);

	die $response->status_line unless $response->is_success; #TODO

	#get cookies
	foreach $h ($response->headers->header('Set-Cookie'))
	{
		if($h =~ /^([^=]+)=([^;]+);/)
		{
			if($cookie)
			{
				$cookie .= "; $1=$2";
			}
			else
			{
				$cookie = "$1=$2";
			}
		}
	}
}

##
#Խ ID ̿Ͽ Խù    RSS Ѵ.
#
sub freechal_board {
	my ($groupid) = @_;

	#get web page
	$response = $browser->get($url, 'Cookie'=>$cookie );

    #
	# Make rss elements
	#
	
	my $ctitle = "[F] ";

	# make items
	my @trs = split /(<tr)/, $response->content;
	foreach $tr (@trs)
	{
		if($tr =~ /<title>([^\[]+)\[http:/)
		{
			$ctitle .= $1;
		}
		elsif($tr =~ /skin_title1.gif">&nbsp;([^\n<]+)(\n|<)/)
		{
			$ctitle .= $1;
		}

		if($tr =~ /class="list"/)
		{
			my $title, $link, $desc;

			#init link
			$link = "";

			#doc number
			if($tr =~ />([0-9]+)(<img src=[^>]+>)?<\/td>[^<]/) {
				$title = "$1: ";
			} else {
				$title = "RE: ";
			}

			#title & URL
			if($tr =~ /<a href=\"(C[^\"]+)[^>]+>([^<]+)[^\[]*(\[[0-9]+\])?/) {
				$title .= "$2 $3";
				$link = $base_url.$1;
				$title =~ s/&nbsp;//g;
				$title =~ s/&/&amp;/g;
				$link =~ s/&/&amp;/g;
			}

			#author
			my $iauthor = "";
			if($tr =~ />([^>( ]+) ?\(<[^>]+>(<[^>]+>)?([[:alnum:]]+)</) {
				$iauthor = "$1($3)";
			} elsif($tr =~ /<font class=\"list\">([^<]+)<\/font>/) {
				$iauthor = $1;
			}

			#date
			my $idate = "";
			if($tr =~ />([0-9]{4})\/([0-9]{2})\/([0-9]{2})/)
			{
				$idate = "$1-$2-$3";
			}
			elsif($tr =~ /([0-9]{4}) ([0-9]{1,2}) </)
			{
				$idate = "$1-$2";
			}

			#access count
			#my $desc="";
			#if($tr =~ /.*>([0-9]+)<\/td>/) {
			#	$desc .= " ($1)";
			#}
		
			if($link)
			{
				$rss->add_item( title=>$title,
					link=>$link,
					#description=>$desc,
					dc=>{ date => $idate,
						creator => $iauthor }
				);
			}
		}
	}

	$url =~ s/&/&amp;/g;
	my @date = localtime;
	$dstr = sprintf "%4d-%02d-%02dT%02d:%02d+09:00",
			$date[5]+1900,$date[4]+1,$date[3],$date[2],$date[1];
	$rss->channel(title => $ctitle,
			link => $url,
			description=>"Recent articles from $ctitle",
			dc=>{ date => $dstr, },
	);
	
}

##
#ÿ Ϲڽ  Ͽ  RSS Ѵ.
#
sub freechal_mail {
	my $url = 'http://mail.freechal.com/MessageCenter/Email/McMsgList.asp?fn=INBOX&gfdr=1&genv=0';
	my $base = 'http://mail.freechal.com/MessageCenter/Email/';

	#get web page
	$response = $browser->get($url, 'Cookie'=>$cookie );

    #
	# Make rss elements
	#
	
	my $ctitle = "[F] Mail";

	# make items
	my @trs = split /(<tr)/, $response->content;
	my $iauthor, $ititle, $ilink, $idate;
	foreach $tr (@trs)
	{
		$ilink = "";

		if($tr =~ /McSendMailForm.asp[^>]+title="([^"]+)">/)
		{
			$iauthor = $1;
		}
		if($tr =~ /(McGetSeqMsg.asp[^"]+)">(<[^>]*>)*([^<]*)</)
		{
			$ilink = $base.$1;
			$ititle = $3;
			$ilink =~ s/&/&amp;/g;
			$ititle =~ s/&/&amp;/g;
		}
		if($tr =~ />([0-9]{4})\/([0-9]{2})\/([0-9]{2})</)
		{
			$idate = "$1-$2-$3";
		}

		if($ilink)
		{
		#print "$ititle $idate $iauthor\n";
			$rss->add_item( title=>$ititle,
				link=>$ilink,
				dc=>{ date => $idate,
					creator => $iauthor }
			);
		}
	}

	$url =~ s/&/&amp;/g;
	my @date = localtime;
	$dstr = sprintf "%4d-%02d-%02dT%02d:%02d+09:00",
			$date[5]+1900,$date[4]+1,$date[3],$date[2],$date[1];
	$rss->channel(title => $ctitle,
			link => $url,
			description=>"Recent Mails on $ctitle",
			dc=>{ date => $dstr, },
	);
}

##
# Main Routine
#

#   н尡 Ǿ  αѴ.
freechal_login($userid, $password) if($userid and $password);

# Խ Ǿ  ش Խ RSS Ѵ.
if( $boardid> 0)
{
	freechal_board($boardid);
} else { 
# ׷  Ϲڽ RSS Ѵ.
	die "ID and PW must be specified\n" unless ($userid and $password);
	freechal_mail;
}

$rss->{output} = $rss_version;

# RSS 
print $rss->as_string;
