#!/usr/bin/perl

# IMAP  ̿Ͽ INBOX    RSS feed Ѵ.
# status: developing
# revision:
# 	2004 4 30 ó ; UTF-8 Ϻ  ó ϰ ִ.
# :
# 	Ʒ ũ  URL, IMAP ,    йȣ õ 
# 	 Ѵ.

use Mail::IMAPClient;
use MIME::Base64;
use XML::RSS;
#use Encode qw/encode decode/;

# Ͽ  Web ̽ ִٸ  URL ϰ, ٸ  ˾Ƽ..
my $url = "http://mail.kr/email/webinterface.cgi";

# IMAP 
my $imap_server ="mail.kr";

#  
my $userid = "id";

#  йȣ
my $password = "password";


my $rss = new XML::RSS(encoding=>"euc-kr");

my $imap = Mail::IMAPClient->new(
		Server=>$imap_server,
		User=>$userid,
		Password=>$password,
		Clear=>5,
) or die "cannot connect $@";

#  Ϲڽ ̸ INBOX ƴ϶, ϶
$imap->select("INBOX") or die "Could not select: $@\n";

my @months = ( "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec" );

# Subject, From ʵ Ư ǥ ڷ ġȯѴ.
sub escape
{
	my ($str) = @_;

	while($str =~ /([^=]*)=\?ks_c_5601-1987\?B\?([^\?]+)\?=(.*)/)
	{
		$str = $1.decode_base64($2).$3;
	}
	while($str =~ /([^=]*)=\?EUC-KR\?B\?([^\?]+)\?=(.*)/)
	{
		$str = $1.decode_base64($2).$3;
	}
	while($str =~ /([^=]*)=\?euc-kr\?B\?([^\?]+)\?=(.*)/)
	{
		$str = $1.decode_base64($2).$3;
	}
	while($str =~ /([^=]*)=\?euc-kr\?q\?([^\?]+)\?=(.*)/)
	{
		my $pre = $1;
		my $mid = $2;
		my $end = $3;
		$mid =~ s/_/ /g;
		$mid =~ s/=[0-9A-Fa-f]{2}/\?/g;
		$str = $pre.$mid.$end;
	}
	while($str =~ /([^=]*)=\?utf-8\?B\?([^\?]+)\?=(.*)/)
	{
		$str = $1.$3;
		#$str = $1.decode_base64($2).$3;
		#TODO use Encode qw/encode decode/; $euc_kr = encode("euc-kr", $utf8);
	}

	$str =~ s/&/&amp;/g;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F]//g;

	return $str;
}

@im = $imap->search("ALL");

#    , Žð, ۽ڸ Ѵ.
for my $m ( @im ){
	$date = "";

	$h = $imap->parse_headers( $m, "Subject", "Received", "From"); #"Date"
	$subj = escape($h->{"Subject"}[0]);
	$from = escape($h->{"From"}[0]);
	$date = $h->{"Received"}[0];
	$date =~ /([0-9]{1,2}) ([A-Z][a-z][a-z]) ([0-9]{2,4}) ([0-9]{2}:[0-9]{2}:[0-9]{2})/;
	if($1<10){ $d = "0".$1; } else { $d = $1; }
	if($3<100) { $pred = "20".$3."-" } else { $pred = $3."-"; }
	$mstr=$2; $postd="-$d"."T$4+09:00";

	$mon = 0;
	for(my $i=0; $i<12; $i++)
	{
		if($mstr =~ /$months[$i]/) { $mon = $i + 1; }
	}
	if($mon<10) { $mon = "0".$mon; }

	$date = $pred.$mon.$postd;
	$subj = "(no subject)" if(!$subj);

	$rss->add_item( title=> $subj,
					link => $url."?".$m,
					dc=>{ date=>$date, creator=>$from, } );
}

$dstr = sprintf "%4d-%02d-%02dT%02d:%02d+09:00",
		$date[5]+1900,$date[4]+1,$date[3],$date[2],$date[1];

$rss->channel(title=>"",
		link=>$url,
		description=>"IMAP Mail Box",
		dc=>{ date = $dstr, },
		syn=>{ updatePeriod => "hourly", updateFrequency => "6", },
);

$rss->{output} = $rss_version;

print "Content-type: application/xml\n\n";
print $rss->as_string;
