#!/usr/bin/perl -w

# Cyworld ̴Ȩ Ȩ ߾ ܿ ǥõǴ  Խù Ʈ  RSS
# Ѵ.  guest  ̴Ȩǿ ϹǷ, 1̰ Խù 
#   Ѵ.
#
# Queries:
#	ver:  RSS version
#	ids: ̴Ȩ . tid:nick,id:nick,...,tid:nick  ڿ̸,
#		tid ̴Ȩ  ȣ HTMLҽ Ȯ  ִ.
#		tid  http://www.cyworld.com/<id>  id   
#		ִ. nick  ̴.
#
#	(뿹)
#	minihp_board.pl?ids=22222222:Friend1,someid:ƹ,23455432:浿
#
# status: developing
# revision:
#   2005 5  3 ϸ   ߸  ̹ item 
#	2005 3 15 ids id:nick ° ϵ 
# 	2005 2 17 ó 

#use strict;
use LWP;
use URI;
use HTTP::Cookies;
use XML::RSS;
use HTML::Parser;
use CGI qw(:standard);

# tid:nick ֵ query  ʰ  ڵ忡 Ϸ   
#  ˴ϴ. ) $ids="22222222:Friend1,12345678:ƹ,23455432:浿";
#$ids="";

# Configurations from the query string
my $url;
my $rss_version;
my $filter="pimslink.*'[0-9]";
my $debug = 0;
my $base;
my $charset = "EUC-KR";
my $index = 1;
my $author;
my $tid;

if(param())
{
	if($ids == "" )
	{
		$ids = param('ids');       # tid:nick pairs
	}
	$rss_version = param('ver');   # RSS version
	$debug = param('debug');       # debugging mode
}

my @idarr = split(/,/, $ids);

$baseurl="http://211.115.10.215/pims/main/main_inside.asp?tid=";

# ⺻ 
$rss_version = '1.0' unless($rss_version);
my $rss = new XML::RSS;

########## Global Variables ##########
my $a_flag = 0;
my $title_flag = 0;
my $h1_flag = 0;

my $title = "";
my $link = "";
my $href = "";
my $img_src = "";
my $img_alt = "";

my $browser =  LWP::UserAgent->new(timeout=>5, agent=>"");


########### AUX Functions: String Converters ###########

# replace special characters
sub escape
{
	my ($str) = @_;
	
	$str =~ s/&/&amp;/g;
	$str =~ s/&amp;amp;/&amp;/g; # recover to &amp;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/&nbsp;/ /g;
	$str =~ s/\r|\n/ /g;
	$str =~ s/ +/ /g;
	$str =~ s/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F]//g;
	$str =~ s/^[ \t]+//g;
	$str =~ s/[ \t]+$//g;
	return $str;
}

# make url from anchor href
sub make_link
{
	my ($base_url, $ref) = @_;
	my $home = "";

	if($base_url =~ /(http:\/\/[^\/]+\/)/)
	{
		$home = $1;
	}

	#$ref =~ s/$link_s_org/$link_s_dst/g if($link_s_org);
	$ref =~ s/&/&amp;/g;
	$ref =~ s/&amp;amp;/&amp;/g;
	$base_url = $home if($ref =~ /^\//);
	$base_url =~ s/\/$//g; # remove ending '/'
	$ref = "/".$ref if(not($ref =~ /^(\/|http:)/)); # add starting '/'
	$ref = $base_url.$ref if(not($ref =~ /^http:/));

	return $ref;
}


########## HTML Parsing Handlers ##########
#
sub start_handler
{
	my ($tag, $attr, $origtext) = @_;
	if($tag =~ /^a$/) # <A>
	{
		if(defined $attr->{'href'})
		{
			$href = $attr->{'href'};
			if( (not $filter) || ($href =~ /$filter/))
			{
				$img_src = "";
				$img_alt = "";
				$a_flag = 1;
			}
		}
	}
	elsif($tag =~ /^meta$/) # <META>
	{
		if( (defined $attr->{'http-eqiv'}) &&
			($attr->{'http-eqiv'}  =~ /content-type/i) )
		{
			if($attr->{'content'} =~ /charset[ \t'"\/>]*([^ \t'"\/>]+)/)
			{
				$charset = $1;
				print "Charset is $charset\n" if $debug;
			}
		}
	}
	elsif($tag =~ /^img$/) # <IMG>
	{
		if($a_flag)
		{
			$img_src = $attr->{'src'};
			$img_alt = $attr->{'alt'} if(defined $attr->{'alt'});
			print "IMG SRC: $img_src ALT: $img_alt\n" if $debug;
		}
	}
	elsif($tag =~ /^title$/) # <TITLE>
	{
		$title_flag = 1;
	}
	elsif($tag =~ /^h1$/) # <H1>
	{
		$h1_flag = 1;
	}
	else
	{
		if($a_flag)
		{
			$title .= $origtext;
		}
	}
}

sub end_handler
{
	my ($tag, $origtext) = @_;

	if(($tag =~ /^a$/) && $a_flag) # </A>
	{
		$a_flag = 0;
		$title =~ s/\n//g; #temp
		$title = escape($title);
		$title = $img_alt if(not $title);
		$title = $img_src if(not $title);
		$title = "(no title)" if(not $title);
		$link = make_link($base, $href);
		print "LINK: $link\nTITLE: $title\n" if $debug;

		# add item
		if($link)
		{
		  if(not ($title =~ /http:\/\/img\.cyworld/))
		  {
			$rss->add_item( title=>$title, link=>
				"http://minihp.cyworld.nate.com/pims/main/pims_main4.asp?tid=".
			$tid, dc=>{ creator => $author, });
		  }
		}

		$href = "";
		$title = "";
	} # end of </A>
	elsif(($tag =~ /^title$/) && $title_flag) # </TITLE>
	{
		$title_flag = 0;
	}
	elsif(($tag =~ /^h1$/) && $h1_flag) # </H1>
	{
		$h1_flag = 0;
	}
	else
	{
		if($a_flag)
		{
			$title .= $origtext;
		}
	}
}

sub text_handler
{
	my ($text) = @_;

	if($a_flag)
	{
		$title .= $text;
	}
	elsif($title_flag)
	{
		#$channel_title = $text;
	}
	elsif($h1_flag)
	{
		#$channel_title .= $text if not $channel_title;
	}
}


########## Main Routine ##########

# Initiailze HTML Parser
my $p = HTML::Parser->new(api_version => 3);
$p->handler( start => \&start_handler,"tagname, attr, text");
$p->handler( end => \&end_handler,"tagname, text");
$p->handler( text => \&text_handler,"text");

# Print out HTTP Header
my $content_type = $debug ? "Content-type: text/plain" : 
		"Content-type: application/xml";
print $content_type."\n\n";

#get web page & add items to RSS
my $pcid = 'web2rss_minihp_board'.int(rand(99999));
foreach $id (@idarr)
{
	@idpair = split (/:/,$id);
	$tid = $idpair[0];
	if($tid =~ /[^0-9]/) # convert 'id' into 'tid'
	{
		my $response = $browser->get("http://cyworld.nate.com/$tid",
			'Host'=>'minihp.cyworld.nate.com',
			'Cookie'=>'pcid=$pcid',
			'User-Agent'=>'Mozilla/5.0');
		$response->content =~ /asp\?tid=([0-9]+)/;
		$tid = $1;
	}

	$author = $idpair[1];
	$url = $baseurl.$tid;
	print "tid=".$idpair[0]." name=".$idpair[1]."\n" if $debug;
	my $response = $browser->get($url,
		'Host'=>'minihp.cyworld.nate.com',
		#'Cookie'=>'pcid=110164020423425844',
		'Cookie'=>'pcid=$pcid',
		'User-Agent'=>'Mozilla/5.0');
	my $ct = $response->header("Content-type");

	$response->base =~ /(.*\/)[^\/]*$/;
	$base = $1;
	print "BASE: $base\n" if $debug;

#TEMP
#print("TEMP\n");
#print($response->content);
#print("\nTEMP\n");

	# encoding character set from HTTP Response Header
	if($ct =~ /charset=['"]?([^'",; ]+)['"]?/i)
	{
		$charset = $1;
	}

	# parse HTML and make RSS
	$p->parse($response->content);
}

	# make up RSS
	my @date = localtime;
	my $dstr = sprintf "%4d-%02d-%02dT%02d:%02d+09:00",
			$date[5]+1900,$date[4]+1,$date[3],$date[2],$date[1];
	#$channel_title = escape($channel_title);

	$url =~ s/&/&amp;/g;
	$rss->channel(title => "̴Ȩ Main",
			#link => $url,
			link => "http://cyworld.nate.com/common/main.asp",
			description=>"̿ ̴Ȩ  Խù",
			dc=>{ date => $dstr, },
			#syn=>{ updatePeriod => "hourly", updateFrequency => "6", },
	);
	
	$rss->{output} = $rss_version;
	$rss->{encoding} = $charset;
	print "Charset: $charset\n" if $debug;

	print $rss->as_string;

# THE END
