#!/usr/bin/perl -w

# Cyworld ̴Ȩ Ͽ  RSS Ѵ.
#
# Queries:
#	ver:  RSS version
#	ids: ̴Ȩ . tid:nick,tid:nick,...,tid:nick  ڿ̸,
#		tid ̴Ȩ  ȣ HTMLҽ Ȯ  ִ.
#		tid  http://www.cyworld.com/<id>  id   
#		ִ. nick  ̴.
#
#	(뿹)
#	minihp_visit.pl?ids=22222222:Friend1,someid:ƹ,23455432:浿
#
# status: developing
# revision:
#   2005 6 30    ְ  
#   2005 6 22    ݿ
#   2005 3 15 ids id:nick ° ϵ 
# 	2005 2 17 ó 

#use strict;
use LWP;
use URI;
use HTTP::Cookies;
use XML::RSS;
use HTML::Parser;
use CGI qw(:standard);

# tid:nick ֵ query  ʰ  ڵ忡 Ϸ   
#  ˴ϴ. ) $ids="22222222:Friend1,12345678:ƹ,23455432:浿";
#$ids="";

# Configurations from the query string
my $url;
my $rss_version;
my $debug = 0;
my $base;
my $channel_title = "";
my $charset = "EUC-KR";
my $index = 1;
my $fishing_time = 0;
my $time = "";
my $time_flag = 0;

if(param())
{
	if($ids == "")
	{
		$ids = param('ids');      # tid:nick pairs
	}
	$rss_version = param('ver');  # RSS version
	$debug = param('debug');      # debugging mode
}

my @idarr = split(/,/, $ids);

$baseurl="http://211.115.10.215/pims/visitbook/visitbook_list.asp?tid=";

# ⺻ 
$rss_version = '1.0' unless($rss_version);
my $rss = new XML::RSS;

########## Global Variables ##########
my $visitor_author = "";
my $reply_author = "";
#my $title = "";
my $link = "";
my $href = "";

my $browser =  LWP::UserAgent->new(timeout=>5, agent=>"");


########### AUX Functions: String Converters ###########

# replace special characters
sub escape
{
	my ($str) = @_;
	
	$str =~ s/&/&amp;/g;
	$str =~ s/&amp;amp;/&amp;/g; # recover to &amp;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/&nbsp;/ /g;
	$str =~ s/\r|\n/ /g;
	$str =~ s/ +/ /g;
	$str =~ s/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F]//g;
	$str =~ s/^[ \t]+//g;
	$str =~ s/[ \t]+$//g;
	return $str;
}

# make url from anchor href
sub make_link
{
	my ($base_url, $ref) = @_;
	my $home = "";

	if($base_url =~ /(http:\/\/[^\/]+\/)/)
	{
		$home = $1;
	}

	$ref =~ s/&/&amp;/g;
	$ref =~ s/&amp;amp;/&amp;/g;
	$base_url = $home if($ref =~ /^\//);
	$base_url =~ s/\/$//g; # remove ending '/'
	$ref = "/".$ref if(not($ref =~ /^(\/|http:)/)); # add starting '/'
	$ref = $base_url.$ref if(not($ref =~ /^http:/));

	return $ref;
}


########## HTML Parsing Handlers ##########
#
sub start_handler
{
	my ($tag, $attr, $origtext) = @_;

	if($tag =~ /^a$/) # <A>
	{
		if(defined $attr->{'href'})
		{
			$href = $attr->{'href'};
			if( $href =~ /PZPopup/)
			{
				if( $href =~ /$tid/ )
				{
					$is_owner = 1;
				}
				else
				{
					$is_owner = 0;
				}
				$author_flag = 1;
				$fishing_time = 1;
			}
		}
	}
	elsif($tag =~ /^font$/) #<FONT>
	{
		$color = "";
		if(defined $attr->{'color'})
		{
			$color = $attr->{'color'};
		}

		if(($is_visitor_title) && ($color =~ /888888/))
		{
			$author_flag = 1;
		}
		else
		{
			$author_flag = 0;
		}

		if($fishing_time)
		{
			$time = "";
			$time_flag = 1;
		}
	}
	elsif($tag =~ /^br/)
	{
		$visitor_body_str .= "&lt;br&gt;"
			if(($is_visitor_body) && ($visitor_body_str));
		$reply_body_str .= "&lt;br&gt;" if($is_reply);
	}
	elsif($tag =~ /^table/)
	{
		#$author = "";
		#$link = "";

		$table_depth ++;
		$background = "";
		$bgcolor = "";
		$width = "";
		$cellpadding = "";

		if(defined $attr->{'background'})
		{
			$background = $attr->{'background'};
		}
		if(defined $attr->{'width'})
		{
			$width = $attr->{'width'};
		}
		if(defined $attr->{'bgcolor'})
		{
			$bgcolor = $attr->{'bgcolor'};
		}
		if(defined $attr->{'cellpadding'})
		{
			$cellpadding = $attr->{'cellpadding'};
		}

		if(($background =~ /p_top_bg/) && ($width =~ "400"))
		{
			$is_visitor_title = 1;
			$visitor_title_str = "";
			$visitor_author = "";
		}
		elsif($width =~ "370")
		{
			$is_visitor_body = 1;
			$visitor_body_str = "";
		}
		elsif(($table_depth == 2) && ($width =~ "364")
				&& ($cellpadding =~ "10"))
		{
			$is_reply = 1;
			$reply_body_str = "";
			$reply_author = "";
		}
		#print "TABLE DEPTH: $table_depth  w:$width $background\n";
	}
}

sub end_handler
{
	my ($tag, $origtext) = @_;

	if(($tag =~ /^a$/) && $author_flag) # </A>
	{
		#print "\nAUTHOR: $author\n" if($debug);
		$author_flag = 0;
		$link = make_link($base, $href);
	} # end of </A>
	elsif(($tag =~ /^font$/) && $time_flag) # </FONT>
	{
		$time =~ s/[\x0a\x0d	()]//g;
		$time =~ s/   / /g;
		$time =~ s/  / /g;
		$link = "http://minihp.cyworld.nate.com/pims/visitbook/visitbook_list.asp?tid="
			.$tid."#".$time;
		$link =~ s/[ ]//g;
		if($is_owner)
		{
			$title = $nick." / -  ".$time;
		}
		#else
		#{
		#	$title = $nick." /".$author." ".$time;
		#}
		#print "LINK: $link\nTITLE: $title\n" if $debug;
		#$href = "";
		$fishing_time = 0;
		$time_flag= 0;
	}
	elsif($tag =~ /^table$/)
	{
		$table_depth --;

		if($is_reply)
		{
			print "\nRA:$reply_author\nL:$link\nT:$nick/ - $time\nD:$reply_body_str\n" if($debug);
			$rss->add_item(
				title=>"$nick / - ($time)",
				link=>$link,
				description=>$reply_body_str,
				dc=>{ creator => $reply_author} );
			$is_reply = 0;
		}
		elsif($is_visitor_body && $table_depth==1)
		{
			$rss->add_item(
				title=> "$nick/ $visitor_title_str",
				link=>$link,
				description=>$visitor_body_str,
				dc=>{ creator => $visitor_author} );
			print "\nA:$visitor_author\nL:$link\nT:$nick/$visitor_title_str\nD:$visitor_body_str\n" if($debug);
			$is_visitor_body = 0;
		}

		$is_visitor_title = 0;
		#print "TABLE DEPTH- $table_depth\n";
	}
}

sub text_handler
{
	my ($text) = @_;

	if($author_flag)
	{
		if($is_visitor_title)
		{
			$visitor_author .= $text;
		}
		elsif($is_reply)
		{
			$reply_author .= $text;
		}
	}
	elsif($time_flag && $fishing_time)
	{
		$time .= $text;
	}

	if($is_visitor_title)
	{
		
		if($text =~ /[^ \t\n\r]/)
		{
			$text =~ s/[\t\n\r]//g;
			$text ="[".$text."] " if($text =~ /^[0-9]+$/);
			$visitor_title_str .= $text;
			#print "VT: $visitor_title_str\n";
		}
	}
	elsif($is_visitor_body)
	{
		if($text =~ /[^ \t\n\r]/)
		{
			$text =~ s/[\t\n\r]/ /g;
			$visitor_body_str .= escape($text);
		}
	}
	elsif($is_reply && $reply_author)
	{
		$reply_body_str .= $text;
	}
}


########## Main Routine ##########

# Initiailze HTML Parser
my $p = HTML::Parser->new(api_version => 3);
$p->handler( start => \&start_handler,"tagname, attr, text");
$p->handler( end => \&end_handler,"tagname, text");
$p->handler( text => \&text_handler,"text");

# Print out HTTP Header
my $content_type = $debug ? "Content-type: text/plain" : 
		"Content-type: application/xml";
print $content_type."\n\n";

#get web page & add items to RSS
my $pcid = 'web2rss_minihp_visit'.int(rand(99999));
foreach $id (@idarr)
{
	@idpair = split (/:/, $id);
	$tid = $idpair[0];
	if($tid =~ /[^0-9]/) # convert 'id' into 'tid'
	{
		my $response = $browser->get("http://cyworld.nate.com/$tid",
			'Host'=>'minihp.cyworld.nate.com',
			'Cookie'=>'pcid=$pcid',
			'User-Agent'=>'Mozilla/5.0');
		$response->content =~ /asp\?tid=([0-9]+)/;
		$tid = $1;
	}

	$nick = $idpair[1];
	print "TID: $tid   NICK: $nick\n" if($debug);
	$url = $baseurl.$tid;
	print "URL: $url\n" if($debug);
	my $response = $browser->get($url,
		'Host'=>'minihp.cyworld.nate.com',
		'Cookie'=>'pcid=$pcid; MINIHP=nate_id=:dummy@nomail.kr',
		'User-Agent'=>'Mozilla/5.0');
	my $ct = $response->header("Content-type");

	$response->base =~ /(.*\/)[^\/]*$/;
	$base = $1;
	print "BASE: $base\n" if $debug;

	# encoding character set from HTTP Response Header
	if($ct =~ /charset=['"]?([^'",; ]+)['"]?/i)
	{
		$charset = $1;
	}

# parse HTML and make RSS
	$p->parse($response->content);
}

	# make up RSS
	my @date = localtime;
	my $dstr = sprintf "%4d-%02d-%02dT%02d:%02d+09:00",
			$date[5]+1900,$date[4]+1,$date[3],$date[2],$date[1];

	$url =~ s/&/&amp;/g;
	$rss->channel(title => "̴Ȩ ",
			link => "http://cyworld.nate.com/common/main.asp",
			description=>"̿ ̴Ȩ ",
			dc=>{ date => $dstr, },
			#syn=>{ updatePeriod => "hourly", updateFrequency => "6", },
	);
	
	$rss->{output} = $rss_version;
	$rss->{encoding} = $charset;
	print "Charset: $charset\n" if $debug;

	print $rss->as_string;

# THE END
