#!/usr/bin/perl

# ֿ л Ӹ鿡  RSS feed ϴ perl script
# status: unstable
# revision:
# 	2006 1 23 top.hani.co.kr Ѱܷ Ӹ 
#   2005 7 21 Ѱܷ   ݿ
#   2005 5 23 Ѱܷ   ݿ
#	2004 4 30 ̴ ߰
#	2004 4 22 ó ; Ѱܷ, þ Ӹ
#
# :
#	 query  ʿ.
#	script ϴܿ  Լ ȣ κп ڸƮ óϸ,  ʴ
#	л 縦   ִ.

use LWP;
use URI;
use HTTP::Cookies;
use XML::RSS;
use CGI qw(:standard);

# Configurations from the query string
if(param())
{
	$rss_version = param('ver'); # RSS version
	$debug = param('debug'); # debugging mode
}

# HTTP Header
$content_type = $debug ? "Content-type: text/plain" : 
		"Content-type: application/xml";
print $content_type."\n\n";

# ⺻ 
$rss_version = '1.0' unless($rss_version);

my $rss = new XML::RSS(encoding=>"euc-kr");
my $browser =  LWP::UserAgent->new;

# replace special characters
sub escape
{
	my ($str) = @_;

	$str =~ s/&/&amp;/g;
	$str =~ s/</&lt;/g;
	$str =~ s/>/&gt;/g;
	$str =~ s/&nbsp;/ /g;
	$str =~ s/\r|\n/ /g;
	$str =~ s/ +/ /g;
	$str =~ s/[\x00-\x08\x0B\x0C\x0E-\x1F\x7F]//g;

	return $str;
}

# make url from anchor href
sub make_link
{
	my ($base, $ref) = @_;

	$ref =~ s/&/&amp;/g;
	$base =~ s/\/$//g; # remove ending '/'
	$ref = "/".$ref if(not($ref =~ /^(\/|http:)/)); # add starting '/'
	$ref = $base.$ref if(not($ref =~ /^http:/));

	return $ref;
}


# Ѱܷ
sub hani{

	my $link = "";
	my $title = "";
	my $desc = "";
	my $imgurl = "";

	my $base = "http://top.hani.co.kr/";

	#get web page
	$response = $browser->get($base);

	# make items
	my @tables = split /(<!-- ThumbNail END -->)/, $response->content;
	foreach $table (@tables)
	{
		$title = "";
		$link = "";
		$desc = "";

		#if ($table =~ /<!-- #debate_content/)
		#{
			print "hani FOUND\n" if ($debug);
			if($table =~ /link_000000_01'><b><a href='([^"]+)' *>([^<]+)<\/a>/)
			{
				$link = $1;
				$title = $2;
				if( !($link =~ /http:/ )) { $link = "http://www.hani.co.kr".$link; }
				$link = make_link($base, $link);
				$title =~ escape($title);

				print("L: $link\n") if($debug);
			}

			if($table =~ /font-size: 12px; line-height: 18px; color: #777777;'>([^<]+)</)
			{
				$desc = $1;
			}
			if($table =~ /font-size: 11px; color: #888888;'>\[([^< ]+) ([:0-9]+)\]</)
			{
				$dstr = $1."T".$2."+09:00";
			}
		#}

		if($link)
		{
			$desc = escape($desc);
	
			print "link: $link\ntitle: $title\ndesc: $desc\n" if $debug;
			$rss->add_item( title=>$title,
					link=>$link,
					description=>$desc,
					dc=>{ creator=>"Ѱܷ", date => $dstr, }
			)
		}
	}
}

# þ
sub pressian{

	my $link = "";
	my $title = "";
	my $desc = "";
	my $imgurl = "";

	my $base = "http://www.pressian.com/";

	#get web page
	$response = $browser->get($base."main.html");

	# make items
	my @tables = split /(<table)/, $response->content;
	foreach $table (@tables)
	{
		if($table =~ /<a href="([^"]+)" class="t_1[abc]?">([^<]+)</)
		#if($table =~ /<a href="([^"]+)" class="t_1[abc]?">([^<]+)<\/a>/)
		{
			$link = $1;
			$title = $2;
			$link = make_link($base, $link);
			$title = escape($title);

			my @trs = split /(<tr)/, $table;
			foreach $tr (@trs)
			{
				$tr =~ s/\r/ /g;
				$tr =~ s/\n/ /g;
				if($tr =~ /class="t_[2-4a]+">([^<]+)<\/a>/)
				{
					$desc .= " ".$1;
				}
				if($tr =~ /<img src="([^"]+)"/)
				{
					$imgurl = $1;
				}
			}

			break;
		}

	}

	$desc = escape($desc);
	print "link: $link\ntitle: $title\ndesc: $desc\nimg: $imgurl\n" if $debug;
	$rss->add_item( title=>$title,
			link=>$link,
			description=>$desc,
			dc=>{ creator=>"þ", }
	)
}

sub ohmynews{

	my $link = "";
	my $title = "";
	my $desc = "";

	my $base = "http://www.ohmynews.com/";
	#get web page
	$response = $browser->get($base);
	$str = $response->content;
	
	# make items
	
	# title and link
	while ($str =~ /(<[aA] class=mtitle01 +href="[^"]+">.+)<\/[aA]>/)
	{
	    $str = $1;
	}   
	$str =~ /<[aA] class=mtitle01 +href="([^"]+)">(.+)/;

	$raw_link = $1;
	$title = $2;
	$link = make_link($base, $raw_link);
	$title = escape($title);

	# description
	$str = $response->content;
	if($str =~ /<td class=contents04><[aA] class=contents04 +href="[^"]+">([^<]+)<\/a><\/td><\/tr>/)
	{
		$desc = $1;
	}
	while ($str =~ /(<[aA] class=sum +href="[^"]+">.+)<\/[aA]>/)
	{
		$str = $1;
	}
	$str =~ /<[aA] class=sum +href="[^"]+">(.+)/;

	$desc = escape($desc."\n".$1);

	print "link: $link\ntitle: $title\ndesc: $desc\n" if $debug;
	$rss->add_item( title=>$title,
			link=>$link,
			description=>$desc,
			dc=>{ creator=>"̴", }
	)
}

#	my @date = localtime;
#	$dstr = sprintf "%4d-%02d-%02dT%02d:%02d+09:00",
#			$date[5]+1900,$date[4]+1,$date[3],$date[2],$date[1];
	$rss->channel(title => "Ź",
			link => "http://localhost/rss/topnews.pl",
			description=>"Top news from various news sites",
#			dc=>{ date => $dstr, },
			syn=>{ updatePeriod => "hourly", updateFrequency => "6", },
	);

#  ʴ Ʈ , # ٿ ڸƮ óϼ.
hani;		# Ѱܷ
pressian;	# þ
#ohmynews;	# ̴ (  ȵ˴ϴ)

$rss->{output} = $rss_version;

#print "<?xml-stylesheet href='http://www.w3.org/2000/08/w3c-synd/style.css' type='text/css'?>";
print $rss->as_string;
